Tree view

Vue Bootstrap 5 Tree view plugin

MDB treeview plugin is used to show hierarchical information which starts from the root item and proceed to its children and their respective children. Each item besides the root has a parent and can have children.

The parent is the node which is higher in the hierarchy and the child the one that is lower. Siblings are items which have one and the same parent. Items can be expanded and collapsed.

Note: Read the API tab to find all available options and advanced customization


Basic example - DOM

Initialize tree view structure with MDBTreeview component. If you want to nest your lists - wrap a text of a li tag in a tag and define other ul after it. Add .show class to the list that you want to expand from the beginning.

        
            
            <template>
              <MDBTreeview>
                <ul>
                  <li>One</li>
                  <li>Two</li>
                  <li>
                    <a>Three</a>
                    <ul class="show">
                      <li>Second-one</li>
                      <li>Second-two</li>
                      <li>
                        <a>Second-three</a>
                        <ul>
                          <li>
                            <a>Third-one</a>
                            <ul>
                              <li>Fourth-one</li>
                              <li>Fourth-two</li>
                              <li>Fourth-three</li>
                            </ul>
                          </li>
                          <li>Third-two</li>
                          <li>
                            <a>Third-three</a>
                            <ul>
                              <li>Fourth-one</li>
                              <li>Fourth-two</li>
                              <li>Fourth-three</li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </MDBTreeview>
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              
              export default {
                components: {
                  MDBTreeview
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
            </script>
          
        
    

Basic example - JavaScript

You can define whole structure of tree using only JavaScript. There are some props in data that you can use to customize it:

  • name - defines a text for an item
  • children - defines a nested list and it's children
  • icon - defines a custom expanding icon for the nested list
  • show - defines if list expands from the beginning or not
  • disabled - defines if list item is disabled or not
        
            
            <template>
              <MDBTreeview
                :structure="[
                  { name: 'One' },
                  { name: 'Two' },
                  {
                    name: 'Three',
                    children: [
                      { name: 'Second-one' },
                      { name: 'Second-two' },
                      {
                        name: 'Second-three',
                        children: [
                          {
                            name: 'Third-one',
                            children: [
                              { name: 'Fourth-one' },
                              { name: 'Fourth-two' },
                              { name: 'Fourth-three' },
                            ],
                          },
                          { name: 'Third-two' },
                          {
                            name: 'Third-three',
                            children: [
                              { name: 'Fourth-one' },
                              { name: 'Fourth-two' },
                              { name: 'Fourth-three' },
                            ],
                          },
                        ],
                      },
                    ],
                  },
                ]"
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              
              export default {
                components: {
                  MDBTreeview
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
            </script>
          
        
    

Open on item click

Use a openOnClick property to define opening lists of treeview by click only on the arrow or on the whole list item.

        
            
            <template>
              <MDBTreeview :openOnClick="false">
                <ul>
                  <li>One</li>
                  <li>Two</li>
                  <li>
                    <a>Three</a>
                    <ul class="show">
                      <li>Second-one</li>
                      <li>Second-two</li>
                      <li>
                        <a>Second-three</a>
                        <ul>
                          <li>
                            <a>Third-one</a>
                            <ul>
                              <li>Fourth-one</li>
                              <li>Fourth-two</li>
                              <li>Fourth-three</li>
                            </ul>
                          </li>
                          <li>Third-two</li>
                          <li>
                            <a>Third-three</a>
                            <ul>
                              <li>Fourth-one</li>
                              <li>Fourth-two</li>
                              <li>Fourth-three</li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </MDBTreeview>
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              
              export default {
                components: {
                  MDBTreeview
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
            </script>
          
        
    

Accordion

Use a accordion property to enable or disable opening only one list at the same level.

        
            
            <template>
              <MDBTreeview accordion>
                <ul>
                  <li>One</li>
                  <li>Two</li>
                  <li>
                    <a>Three</a>
                    <ul class="show">
                      <li>Second-one</li>
                      <li>Second-two</li>
                      <li>
                        <a>Second-three</a>
                        <ul>
                          <li>
                            <a>Third-one</a>
                            <ul>
                              <li>Fourth-one</li>
                              <li>Fourth-two</li>
                              <li>Fourth-three</li>
                            </ul>
                          </li>
                          <li>Third-two</li>
                          <li>
                            <a>Third-three</a>
                            <ul>
                              <li>Fourth-one</li>
                              <li>Fourth-two</li>
                              <li>Fourth-three</li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </MDBTreeview>
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              
              export default {
                components: {
                  MDBTreeview
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
            </script>
          
        
    

Selectable

Use a selectable property to set up checkboxes in every list item.

        
            
            <template>
              <MDBTreeview selectable>
                <ul>
                  <li>One</li>
                  <li>Two</li>
                  <li>
                    <a>Three</a>
                    <ul class="show">
                      <li>Second-one</li>
                      <li>Second-two</li>
                      <li>
                        <a>Second-three</a>
                        <ul>
                          <li>
                            <a>Third-one</a>
                            <ul>
                              <li>Fourth-one</li>
                              <li>Fourth-two</li>
                              <li>Fourth-three</li>
                            </ul>
                          </li>
                          <li>Third-two</li>
                          <li>
                            <a>Third-three</a>
                            <ul>
                              <li>Fourth-one</li>
                              <li>Fourth-two</li>
                              <li>Fourth-three</li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </MDBTreeview>
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              
              export default {
                components: {
                  MDBTreeview
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
            </script>
          
        
    

Expand

Expand your treeview to the particular list using the expand(ID) method.

        
            
            <template>
              <MDBRow class="justify-content-center mb-3">
                <MDBCol md="3">
                  <MDBBtn
                    color="primary"
                    @click="expandExample?.expand('expand-example-item')"
                  >
                    Expand first list
                  </MDBBtn>
                </MDBCol>
              </MDBRow>
              <MDBRow>
                <MDBTreeview ref="expandExample">
                  <ul>
                    <li>One</li>
                    <li>Two</li>
                    <li>
                      <a>Three</a>
                      <ul id="expand-example-item">
                        <li>Second-one</li>
                        <li>Second-two</li>
                        <li>
                          <a>Second-three</a>
                          <ul>
                            <li>
                              <a>Third-one</a>
                              <ul>
                                <li>Fourth-one</li>
                                <li>Fourth-two</li>
                                <li>Fourth-three</li>
                              </ul>
                            </li>
                            <li>Third-two</li>
                            <li>
                              <a>Third-three</a>
                              <ul>
                                <li>Fourth-one</li>
                                <li>Fourth-two</li>
                                <li>Fourth-three</li>
                              </ul>
                            </li>
                          </ul>
                        </li>
                      </ul>
                    </li>
                  </ul>
                </MDBTreeview>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              import { MDBBtn, MDBCol, MDBRow } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              export default {
                components: {
                  MDBTreeview,
                  MDBBtn,
                  MDBCol,
                  MDBRow
                },
                setup() {
                  const expandExample = ref(null);

                  return {
                    expandExample,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
              import { MDBBtn, MDBCol, MDBRow } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const expandExample = ref<InstanceType<typeof MDBTreeview> | null>(null);
            </script>
          
        
    

Collapse

Collapse your treeview using the collapse() method.

        
            
            <template>
              <MDBRow class="justify-content-center mb-3">
                <MDBCol md="3">
                  <MDBBtn color="primary" @click="collapseExample?.collapse()">
                    Collapse treeview
                  </MDBBtn>
                </MDBCol>
              </MDBRow>
              <MDBRow>
                <MDBTreeview class="treeview" ref="collapseExample">
                  <ul>
                    <li>One</li>
                    <li>Two</li>
                    <li>
                      <a>Three</a>
                      <ul class="show">
                        <li>Second-one</li>
                        <li>Second-two</li>
                        <li>
                          <a>Second-three</a>
                          <ul class="show">
                            <li>
                              <a>Third-one</a>
                              <ul class="show">
                                <li>Fourth-one</li>
                                <li>Fourth-two</li>
                                <li>Fourth-three</li>
                              </ul>
                            </li>
                            <li>Third-two</li>
                            <li>
                              <a>Third-three</a>
                              <ul class="show">
                                <li>Fourth-one</li>
                                <li>Fourth-two</li>
                                <li>Fourth-three</li>
                              </ul>
                            </li>
                          </ul>
                        </li>
                      </ul>
                    </li>
                  </ul>
                </MDBTreeview>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              import { MDBBtn, MDBCol, MDBRow } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              
              export default {
                components: {
                  MDBTreeview,
                  MDBBtn,
                  MDBCol,
                  MDBRow
                },
                setup() {
                  const collapseExample = ref();

                  return {
                    collapseExample,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
              import { MDBBtn, MDBCol, MDBRow } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const collapseExample = ref<InstanceType<typeof MDBTreeview> | null>(null);
            </script>
          
        
    

Custom icons - DOM

You can add your custom icons to your treeview. For non-nested elements - paste code of an icon in the item. For nested elements - declare span tag inside a element and paste there the code for your icon.

Use a rotationAngle property to define a rotation angle of nested lists icons.

        
            
            <template>
              <MDBTreeview>
                <ul>
                  <li><i class="fas fa-dot-circle"></i> One</li>
                  <li><i class="fas fa-dot-circle"></i> Two</li>
                  <li>
                    <a>
                      <span><i class="fas fa-angle-double-right"></i></span>
                      Three
                    </a>
                    <ul class="show" id="custom-icon-list">
                      <li><i class="fas fa-dot-circle"></i> Second-one</li>
                      <li><i class="fas fa-dot-circle"></i> Second-two</li>
                      <li>
                        <a
                          ><span><i class="fas fa-angle-double-right"></i></span>
                          Second-three</a
                        >
                        <ul>
                          <li><i class="fas fa-dot-circle"></i> Third-one</li>
                          <li><i class="fas fa-dot-circle"></i> Third-two</li>
                          <li><i class="fas fa-dot-circle"></i> Third-three</li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </MDBTreeview>
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";

              export default {
                components: {
                  MDBTreeview
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
            </script>
          
        
    

Custom icons - JavaScript

Add icons to the list elements by pasting an icon code in the name property. If you want to change the rotatable icon in the nested list - use icon property instead.

        
            
            <template>
              <MDBTreeview :structure="customIconStructure" />
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              import { ref } from "vue";

              export default {
                components: {
                  MDBTreeview
                },
                setup() {
                  const customIconStructure = ref([
                    { name: '<i class="fas fa-dot-circle"></i> One' },
                    { name: '<i class="fas fa-dot-circle"></i> Two' },
                    {
                      name: " Three",
                      show: true,
                      icon: '<i class="fas fa-angle-double-right"></i>',
                      children: [
                        { name: '<i class="fas fa-dot-circle"></i> Second-one' },
                        { name: '<i class="fas fa-dot-circle"></i> Second-two' },
                        {
                          name: " Second-three",
                          icon: '<i class="fas fa-angle-double-right"></i>',
                          children: [
                            {
                              name: " Third-one",
                              icon: '<i class="fas fa-angle-double-right"></i>',
                              children: [
                                { name: '<i class="fas fa-dot-circle"></i> Fourth-one' },
                                { name: '<i class="fas fa-dot-circle"></i> Fourth-two' },
                                { name: '<i class="fas fa-dot-circle"></i> Fourth-three' },
                              ],
                            },
                            { name: '<i class="fas fa-dot-circle"></i> Third-two' },
                            {
                              name: " Third-three",
                              icon: '<i class="fas fa-angle-double-right"></i>',
                              children: [
                                { name: '<i class="fas fa-dot-circle"></i> Fourth-one' },
                                { name: '<i class="fas fa-dot-circle"></i> Fourth-two' },
                                { name: '<i class="fas fa-dot-circle"></i> Fourth-three' },
                              ],
                            },
                          ],
                        },
                      ],
                    },
                  ]);
                  
                  return {
                    customIconStructure
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
              import { ref } from "vue";

              const customIconStructure = ref([
                { name: '<i class="fas fa-dot-circle"></i> One' },
                { name: '<i class="fas fa-dot-circle"></i> Two' },
                {
                  name: " Three",
                  show: true,
                  icon: '<i class="fas fa-angle-double-right"></i>',
                  children: [
                    { name: '<i class="fas fa-dot-circle"></i> Second-one' },
                    { name: '<i class="fas fa-dot-circle"></i> Second-two' },
                    {
                      name: " Second-three",
                      icon: '<i class="fas fa-angle-double-right"></i>',
                      children: [
                        {
                          name: " Third-one",
                          icon: '<i class="fas fa-angle-double-right"></i>',
                          children: [
                            { name: '<i class="fas fa-dot-circle"></i> Fourth-one' },
                            { name: '<i class="fas fa-dot-circle"></i> Fourth-two' },
                            { name: '<i class="fas fa-dot-circle"></i> Fourth-three' },
                          ],
                        },
                        { name: '<i class="fas fa-dot-circle"></i> Third-two' },
                        {
                          name: " Third-three",
                          icon: '<i class="fas fa-angle-double-right"></i>',
                          children: [
                            { name: '<i class="fas fa-dot-circle"></i> Fourth-one' },
                            { name: '<i class="fas fa-dot-circle"></i> Fourth-two' },
                            { name: '<i class="fas fa-dot-circle"></i> Fourth-three' },
                          ],
                        },
                      ],
                    },
                  ],
                },
              ]);
            </script>
          
        
    

Color

Set the color of an active item using the treeviewColor property.

Current color: primary
        
            
            <template>
              <div class="text-center mb-5">
                <MDBBtn color="primary" @click="treeviewColor = 'primary'">
                  Primary
                </MDBBtn>
                <MDBBtn color="secondary" @click="treeviewColor = 'secondary'">
                  Secondary
                </MDBBtn>
                <MDBBtn color="warning" @click="treeviewColor = 'warning'">
                  Warning
                </MDBBtn>
                <MDBBtn color="danger" @click="treeviewColor = 'danger'">
                  Danger
                </MDBBtn>
                <MDBBtn color="info" @click="treeviewColor = 'info'">Info</MDBBtn>
                <MDBBtn color="success" @click="treeviewColor = 'success'">
                  Success
                </MDBBtn>
                <MDBBtn color="dark" @click="treeviewColor = 'dark'">Dark</MDBBtn>
              </div>
              <MDBRow class="text-center">
                <h5>Current color: <span id="current-color">primary</span></h5>
              </MDBRow>
              <MDBRow class="mt-4">
                <MDBTreeview :treeviewColor="treeviewColor">
                  <ul>
                    <li>One</li>
                    <li>Two</li>
                    <li>
                      <a>Three</a>
                      <ul class="show">
                        <li>Second-one</li>
                        <li>Second-two</li>
                        <li>
                          <a>Second-three</a>
                          <ul>
                            <li>
                              <a>Third-one</a>
                              <ul>
                                <li>Fourth-one</li>
                                <li>Fourth-two</li>
                                <li>Fourth-three</li>
                              </ul>
                            </li>
                            <li>Third-two</li>
                            <li>
                              <a>Third-three</a>
                              <ul>
                                <li>Fourth-one</li>
                                <li>Fourth-two</li>
                                <li>Fourth-three</li>
                              </ul>
                            </li>
                          </ul>
                        </li>
                      </ul>
                    </li>
                  </ul>
                </MDBTreeview>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              import { MDBBtn, MDBRow } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              export default {
                components: {
                  MDBTreeview,
                  MDBBtn,
                  MDBRow
                },
                setup() {
                  const treeviewColor = ref("primary");
                  
                  return {
                    treeviewColor
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
              import { MDBBtn, MDBRow } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const treeviewColor = ref<InstanceType<typeof MDBTreeview> | null>(null);
            </script>
          
        
    

Line

Use a line property to set up an additional line in every nested list.

        
            
            <template>
              <MDBTreeview line>
                <ul>
                  <li>One</li>
                  <li>Two</li>
                  <li>
                    <a>Three</a>
                    <ul class="show">
                      <li>Second-one</li>
                      <li>Second-two</li>
                      <li>
                        <a>Second-three</a>
                        <ul>
                          <li>
                            <a>Third-one</a>
                            <ul>
                              <li>Fourth-one</li>
                              <li>Fourth-two</li>
                              <li>Fourth-three</li>
                            </ul>
                          </li>
                          <li>Third-two</li>
                          <li>
                            <a>Third-three</a>
                            <ul>
                              <li>Fourth-one</li>
                              <li>Fourth-two</li>
                              <li>Fourth-three</li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </MDBTreeview>
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              
              export default {
                components: {
                  MDBTreeview
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
            </script>
          
        
    

Disabled - DOM

Add .treeview-disabled class to the a (if nested) or li tag to disable your list item. You can expand disabled items, but you can't select them.

        
            
            <template>
              <MDBTreeview selectable>
                <ul>
                  <li>One</li>
                  <li class="treeview-disabled">Two</li>
                  <li>
                    <a>Three</a>
                    <ul class="show">
                      <li>Second-one</li>
                      <li>Second-two</li>
                      <li class="treeview-disabled">
                        <a>Second-three</a>
                        <ul>
                          <li>
                            <a>Third-one</a>
                            <ul>
                              <li>Fourth-one</li>
                              <li>Fourth-two</li>
                              <li>Fourth-three</li>
                            </ul>
                          </li>
                          <li>Third-two</li>
                          <li>
                            <a>Third-three</a>
                            <ul>
                              <li>Fourth-one</li>
                              <li>Fourth-two</li>
                              <li>Fourth-three</li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
              </MDBTreeview>
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              
              export default {
                components: {
                  MDBTreeview
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
            </script>
          
        
    

Disabled - JavaScript

To generate a disabled list item, use disabled property.

        
            
            <template>
              <MDBTreeview :structure="disabledStructure" />
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              import { ref } from "vue";

              export default {
                components: {
                  MDBTreeview
                },
                setup() {
                  const disabledStructure = ref([
                    { name: "One", disabled: true },
                    { name: "Two" },
                    {
                      name: " Three",
                      show: true,
                      children: [
                        { name: "Second-one" },
                        { name: "Second-two" },
                        {
                          name: " Second-three",
                          disabled: true,
                          children: [
                            {
                              name: " Third-one",
                              children: [
                                { name: "Fourth-one" },
                                { name: "Fourth-two" },
                                { name: "Fourth-three" },
                              ],
                            },
                            { name: "Third-two" },
                            {
                              name: " Third-three",
                              children: [
                                { name: "Fourth-one" },
                                { name: "Fourth-two" },
                                { name: "Fourth-three" },
                              ],
                            },
                          ],
                        },
                      ],
                    },
                  ]);
                  
                  return {
                    disabledStructure
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
              import { ref } from "vue";

              const disabledStructure = ref([
                { name: "One", disabled: true },
                { name: "Two" },
                {
                  name: " Three",
                  show: true,
                  children: [
                    { name: "Second-one" },
                    { name: "Second-two" },
                    {
                      name: " Second-three",
                      disabled: true,
                      children: [
                        {
                          name: " Third-one",
                          children: [
                            { name: "Fourth-one" },
                            { name: "Fourth-two" },
                            { name: "Fourth-three" },
                          ],
                        },
                        { name: "Third-two" },
                        {
                          name: " Third-three",
                          children: [
                            { name: "Fourth-one" },
                            { name: "Fourth-two" },
                            { name: "Fourth-three" },
                          ],
                        },
                      ],
                    },
                  ],
                },
              ]);
            </script>
          
        
    

Filter

Use the .filter(string) method to expand list items that meet your requirements.

        
            
            <template>
              <MDBRow class="mb-4 justify-content-center">
                <MDBCol md="6">
                  <MDBInput
                    v-model="filter"
                    label="Find the treeview"
                    @change="filterExample.filter(filter)"
                  />
                </MDBCol>
              </MDBRow>
              <MDBRow>
                <MDBTreeview ref="filterExample">
                  <ul>
                    <li>One</li>
                    <li>Two</li>
                    <li>
                      <a>Three</a>
                      <ul>
                        <li>Second-one</li>
                        <li>Second-two</li>
                        <li>
                          <a>Second-three</a>
                          <ul>
                            <li>
                              <a>Third-one</a>
                              <ul>
                                <li>Fourth-one</li>
                                <li>Fourth-two</li>
                                <li>Fourth-three</li>
                              </ul>
                            </li>
                            <li>Third-two</li>
                            <li>
                              <a>Third-three</a>
                              <ul>
                                <li>Fourth-one</li>
                                <li>Fourth-two</li>
                                <li>Fourth-three</li>
                              </ul>
                            </li>
                          </ul>
                        </li>
                      </ul>
                    </li>
                  </ul>
                </MDBTreeview>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { MDBTreeview } from "mdb-vue-tree-view";
              import { MDBRow, MDBCol, MDBInput } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              export default {
                components: {
                  MDBTreeview,
                  MDBRow,
                  MDBCol,
                  MDBInput
                },
                setup() {
                  const filter = ref("");
                  const filterExample = ref("");

                  return {
                    filter,
                    filterExample,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreeview } from "mdb-vue-tree-view";
              import { MDBRow, MDBCol, MDBInput } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const filter = ref("");
              const filterExample = ref<InstanceType<typeof MDBTreeview> | null>(null);
            </script>
          
        
    

TAILWIND

GIFT for 2026

Purchase anything during the New Years Sale and get a Tailwind UI kit gift!

Tree view - API


Import

        
            
          <script>
            import { MDBTreeview } from "mdb-vue-tree-view";
          </script>
        
        
    

Properties

Name Type Default Description
accordion Boolean false Allows only one list on the same level to be opened
line Boolean false Adds a line to every nested list
openOnClick Boolean true Enables opening list by clicking only on the icon
tag String 'div' Sets component wrapper tag
treeviewColor String 'primary' Defines a text and background color for an active or hovered item
selectable Boolean false Setup checkboxes for the every list item
structure Array ` Setup structure of tree elements
rotationAngle Number 90 Defines a rotation angle of the icons in nested lists

Methods

Name Description
collapse Collapses every list in treeview
expand('id') Expands a treeview to the list with a particular ID
filter(string) Expands list items that meet your requirements
        
            
        <template>
          <MDBBtn color="primary" @click="treeviewRef?.collapse()"
            >Collapse list</MDBBtn
          >
          <MDBTreeview
            ref="treeviewRef"
            :structure="[
              { name: 'One' },
              { name: 'Two' },
              {
                name: 'Three',
                children: [
                  { name: 'Second-one' },
                  { name: 'Second-two' },
                  {
                    name: 'Second-three',
                    children: [
                      {
                        name: 'Third-one',
                        children: [
                          { name: 'Fourth-one' },
                          { name: 'Fourth-two' },
                          { name: 'Fourth-three' },
                        ],
                      },
                      { name: 'Third-two' },
                      {
                        name: 'Third-three',
                        children: [
                          { name: 'Fourth-one' },
                          { name: 'Fourth-two' },
                          { name: 'Fourth-three' },
                        ],
                      },
                    ],
                  },
                ],
              },
            ]"
          />
        </template>
        
        
    
        
            
        <script>
          import { MDBTreeview } from "mdb-vue-tree-view";
          import { MDBBtn } from "mdb-vue-ui-kit";
          import { ref } from "vue";
          export default {
            components: {
              MDBTreeview,
              MDBBtn,
            },
            setup() {
              const treeviewRef = ref(null);
          
              return {
                treeviewRef,
              };
            },
          };
        </script>
        
        
    
        
            
        <script setup lang="ts">
          import { MDBTreeview } from "mdb-vue-tree-view";
          import { MDBBtn } from "mdb-vue-ui-kit";
          import { ref } from "vue";
          
          const treeviewRef = ref<InstanceType<typeof MDBTreeview> | null>(null);
        </script>
        
        
    

Events

Name Description
select This event fires immediately when one of the treeview checkboxes are changed. Selected items are available with items property of the event.
active-item This event fires immediately when one of the treeview list items are selected by click. Selected item is available with item property of the event.
        
            
          <template>
            <MDBTreeview @select="doSomething" >...</MDBTreeview>
          </template>

Tree view

React Bootstrap 5 Tree view plugin

MDB treeview plugin is used to show hierarchical information which starts from the root item and proceed to its children and their respective children. Each item besides the root has a parent and can have children.

The parent is the node which is higher in the hierarchy and the child the one that is lower. Siblings are items which have one and the same parent. Items can be expanded and collapsed.

Note: Read the API tab to find all available options and advanced customization


Basic example - JSX

        
            
            import React from 'react';
            import { MDBTreeview, MDBTreeviewItem } from 'mdb-react-treeview';

            export default function App() {
              return (
                <MDBTreeview>
                  <MDBTreeviewItem name='One' />
                  <MDBTreeviewItem name='Two' />
                  <MDBTreeviewItem subtree show name='Three'>
                    <MDBTreeviewItem name='Second-one' />
                    <MDBTreeviewItem name='Second-two' />
                    <MDBTreeviewItem name='Second-three' subtree>
                      <MDBTreeviewItem name='Third-one' subtree>
                        <MDBTreeviewItem name='Fourth-one' />
                        <MDBTreeviewItem name='Fourth-two' />
                        <MDBTreeviewItem name='Fourth-three' />
                      </MDBTreeviewItem>
                      <MDBTreeviewItem name='Third-two' />
                      <MDBTreeviewItem name='Third-three' subtree>
                        <MDBTreeviewItem name='Fourth-one' />
                        <MDBTreeviewItem name='Fourth-two' />
                        <MDBTreeviewItem name='Fourth-three' />
                      </MDBTreeviewItem>
                    </MDBTreeviewItem>
                  </MDBTreeviewItem>
                </MDBTreeview>
              );
            }
          
        
    

Basic example - JavaScript

You can define whole structure of tree using only JavaScript. There are some props in data that you can use to customize it:

        
            
            import React from 'react';
            import { MDBTreeview } from 'mdb-react-treeview';

            export default function App() {
              return (
                <MDBTreeview
                  items={[
                    { name: 'One' },
                    { name: 'Two' },
                    {
                      name: 'Three',
                      children: [
                        { name: 'Second-one' },
                        { name: 'Second-two' },
                        {
                          name: 'Second-three',
                          children: [
                            {
                              name: 'Third-one',

                              children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                            },
                            { name: 'Third-two' },
                            {
                              name: 'Third-three',
                              children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                            },
                          ],
                        },
                      ],
                    },
                  ]}
                />
              );
            }
          
        
    

Open on item click

Use a openOnItemClick to define opening lists of treeview by click only on the arrow or on the whole list item.

        
            
            import React from 'react';
            import { MDBTreeview, MDBTreeviewItem } from 'mdb-react-treeview';

            export default function App() {
              return (
                <MDBTreeview openOnItemClick={false}>
                  <MDBTreeviewItem name='One' />
                  <MDBTreeviewItem name='Two' />
                  <MDBTreeviewItem subtree name='Three' show>
                    <MDBTreeviewItem name='Second-one' />
                    <MDBTreeviewItem name='Second-two' />
                    <MDBTreeviewItem name='Second-three' subtree>
                      <MDBTreeviewItem name='Third-one' subtree>
                        <MDBTreeviewItem name='Fourth-one' />
                        <MDBTreeviewItem name='Fourth-two' />
                        <MDBTreeviewItem name='Fourth-three' />
                      </MDBTreeviewItem>
                      <MDBTreeviewItem name='Third-two' />
                      <MDBTreeviewItem name='Third-three' subtree>
                        <MDBTreeviewItem name='Fourth-one' />
                        <MDBTreeviewItem name='Fourth-two' />
                        <MDBTreeviewItem name='Fourth-three' />
                      </MDBTreeviewItem>
                    </MDBTreeviewItem>
                  </MDBTreeviewItem>
                </MDBTreeview>
              );
            }
          
        
    

Selectable

Use a selectable property to set up checkboxes in every list item.

        
            
            import React from 'react';
            import { MDBTreeview, MDBTreeviewItem } from 'mdb-react-treeview';

            export default function App() {
              return (
                <MDBTreeview selectable>
                  <MDBTreeviewItem name='One' />
                  <MDBTreeviewItem name='Two' />
                  <MDBTreeviewItem subtree name='Three'>
                    <MDBTreeviewItem name='Second-one' />
                    <MDBTreeviewItem name='Second-two' />
                    <MDBTreeviewItem name='Second-three' subtree>
                      <MDBTreeviewItem name='Third-one' subtree>
                        <MDBTreeviewItem name='Fourth-one' />
                        <MDBTreeviewItem name='Fourth-two' />
                        <MDBTreeviewItem name='Fourth-three' />
                      </MDBTreeviewItem>
                      <MDBTreeviewItem name='Third-two' />
                      <MDBTreeviewItem name='Third-three' subtree>
                        <MDBTreeviewItem name='Fourth-one' />
                        <MDBTreeviewItem name='Fourth-two' />
                        <MDBTreeviewItem name='Fourth-three' />
                      </MDBTreeviewItem>
                    </MDBTreeviewItem>
                  </MDBTreeviewItem>
                </MDBTreeview>
              );
            }
          
        
    

Expand

        
            
            import React, { useState } from 'react';
            import { MDBTreeview, MDBTreeviewItem } from 'mdb-react-treeview';
            import { MDBRow, MDBCol, MDBBtn } from 'mdb-react-ui-kit';

            export default function App() {
              const [expandExample, setExpandExample] = useState(false);

              return (
                <MDBRow className='justify-content-center mb-3'>
                  <MDBCol md='3'>
                    <MDBBtn style={{ minWidth: '155px' }} onClick={() => setExpandExample(true)}>
                      Expand first list
                    </MDBBtn>
                  </MDBCol>
                </MDBRow>
                <MDBRow>
                  <MDBTreeview>
                    <MDBTreeviewItem name='One' />
                    <MDBTreeviewItem name='Two' />
                    <MDBTreeviewItem subtree show={expandExample} name='Three'>
                      <MDBTreeviewItem name='Second-one' />
                      <MDBTreeviewItem name='Second-two' />
                      <MDBTreeviewItem name='Second-three' subtree>
                        <MDBTreeviewItem name='Third-one' subtree>
                          <MDBTreeviewItem name='Fourth-one' />
                          <MDBTreeviewItem name='Fourth-two' />
                          <MDBTreeviewItem name='Fourth-three' />
                        </MDBTreeviewItem>
                        <MDBTreeviewItem name='Third-two' />
                        <MDBTreeviewItem name='Third-three' subtree>
                          <MDBTreeviewItem name='Fourth-one' />
                          <MDBTreeviewItem name='Fourth-two' />
                          <MDBTreeviewItem name='Fourth-three' />
                        </MDBTreeviewItem>
                      </MDBTreeviewItem>
                    </MDBTreeviewItem>
                  </MDBTreeview>
                </MDBRow>
              );
            }
          
        
    

Collapse

        
            
            import React, { useState } from 'react';
            import { MDBTreeview, MDBTreeviewItem } from 'mdb-react-treeview';
            import { MDBRow, MDBCol, MDBBtn } from 'mdb-react-ui-kit';

            export default function App() {
              const [collapseExample, setCollapseExample] = useState(true);

              return (
                <MDBRow className='justify-content-center mb-3'>
                  <MDBCol md='3'>
                    <MDBBtn style={{ minWidth: '155px' }} onClick={() => setCollapseExample(false)}>
                      Collapse Treeview
                    </MDBBtn>
                  </MDBCol>
                </MDBRow>
                <MDBRow>
                  <MDBTreeview>
                    <MDBTreeviewItem name='One' />
                    <MDBTreeviewItem name='Two' />
                    <MDBTreeviewItem subtree show={collapseExample} name='Three'>
                      <MDBTreeviewItem name='Second-one' />
                      <MDBTreeviewItem name='Second-two' />
                      <MDBTreeviewItem name='Second-three' show subtree>
                        <MDBTreeviewItem name='Third-one' show subtree>
                          <MDBTreeviewItem name='Fourth-one' />
                          <MDBTreeviewItem name='Fourth-two' />
                          <MDBTreeviewItem name='Fourth-three' />
                        </MDBTreeviewItem>
                        <MDBTreeviewItem name='Third-two' />
                        <MDBTreeviewItem name='Third-three' show subtree>
                          <MDBTreeviewItem name='Fourth-one' />
                          <MDBTreeviewItem name='Fourth-two' />
                          <MDBTreeviewItem name='Fourth-three' />
                        </MDBTreeviewItem>
                      </MDBTreeviewItem>
                    </MDBTreeviewItem>
                  </MDBTreeview>
                </MDBRow>
              );
            }
          
        
    

Custom icons - JSX

Use a rotationAngle property to define a rotation angle of nested lists icons.

        
            
            import React from 'react';
            import { MDBTreeview, MDBTreeviewItem } from 'mdb-react-treeview';

            export default function App() {
              return (
                <MDBTreeview>
                  <MDBTreeviewItem
                    name={
                      <>
                        <MDBIcon icon='dot-circle' fas /> One
                      </>
                    }
                  />
                  <MDBTreeviewItem
                    name={
                      <>
                        <MDBIcon icon='dot-circle' fas /> Two
                      </>
                    }
                  />
                  <MDBTreeviewItem subtree show icon='angle-double-right' name='Three'>
                    <MDBTreeviewItem
                      name={
                        <>
                          <MDBIcon icon='dot-circle' fas /> Second-one
                        </>
                      }
                    />
                    <MDBTreeviewItem
                      name={
                        <>
                          <MDBIcon icon='dot-circle' fas /> Second-two
                        </>
                      }
                    />
                    <MDBTreeviewItem name='Second-three' icon='angle-double-right' subtree>
                      <MDBTreeviewItem name='Third-one' icon='angle-double-right' subtree>
                        <MDBTreeviewItem
                          name={
                            <>
                              <MDBIcon icon='dot-circle' fas /> Fourth-one
                            </>
                          }
                        />
                        <MDBTreeviewItem
                          name={
                            <>
                              <MDBIcon icon='dot-circle' fas /> Fourth-two
                            </>
                          }
                        />
                        <MDBTreeviewItem
                          name={
                            <>
                              <MDBIcon icon='dot-circle' fas /> Fourth-three
                            </>
                          }
                        />
                      </MDBTreeviewItem>
                      <MDBTreeviewItem
                        name={
                          <>
                            <MDBIcon icon='dot-circle' fas /> Third-two
                          </>
                        }
                      />
                      <MDBTreeviewItem name='Third-three' icon='angle-double-right' subtree>
                        <MDBTreeviewItem
                          name={
                            <>
                              <MDBIcon icon='dot-circle' fas /> Fourth-one
                            </>
                          }
                        />
                        <MDBTreeviewItem
                          name={
                            <>
                              <MDBIcon icon='dot-circle' fas /> Fourth-two
                            </>
                          }
                        />
                        <MDBTreeviewItem
                          name={
                            <>
                              <MDBIcon icon='dot-circle' fas /> Fourth-three
                            </>
                          }
                        />
                      </MDBTreeviewItem>
                    </MDBTreeviewItem>
                  </MDBTreeviewItem>
                </MDBTreeview>
              );
            }
          
        
    

Custom icons - JavaScript

Add icons to the list elements by pasting an icon code in the name property. If you want to change the rotatable icon in the nested list - use icon property instead.

        
            
            import React from 'react';
            import { MDBTreeview, MDBTreeviewItem } from 'mdb-react-treeview';

            export default function App() {
              return (
                <MDBTreeview
                  items={[
                    {
                      name: (
                        <>
                          <MDBIcon icon='dot-circle' fas /> One{' '}
                        </>
                      ),
                    },
                    {
                      name: (
                        <>
                          <MDBIcon icon='dot-circle' fas /> Two{' '}
                        </>
                      ),
                    },
                    {
                      name: 'Three',
                      subtree: true,
                      icon: 'angle-double-right',
                      children: [
                        {
                          name: (
                            <>
                              <MDBIcon icon='dot-circle' fas /> Second-one{' '}
                            </>
                          ),
                        },
                        {
                          name: (
                            <>
                              <MDBIcon icon='dot-circle' fas /> Second-two{' '}
                            </>
                          ),
                        },
                        {
                          name: 'Second-three',
                          subtree: true,
                          icon: 'angle-double-right',
                          children: [
                            {
                              name: 'Third-one',
                              icon: 'angle-double-right',
                              subtree: true,
                              children: [
                                {
                                  name: (
                                    <>
                                      <MDBIcon icon='dot-circle' fas /> Fourth-one
                                    </>
                                  ),
                                },
                                {
                                  name: (
                                    <>
                                      <MDBIcon icon='dot-circle' fas /> Fourth-two
                                    </>
                                  ),
                                },
                                {
                                  name: (
                                    <>
                                      <MDBIcon icon='dot-circle' fas /> Fourth-three
                                    </>
                                  ),
                                },
                              ],
                            },
                            {
                              name: (
                                <>
                                  <MDBIcon icon='dot-circle' fas /> Third-two
                                </>
                              ),
                            },
                            {
                              name: 'Third-three',
                              subtree: true,
                              icon: 'angle-double-right',
                              children: [
                                {
                                  name: (
                                    <>
                                      <MDBIcon icon='dot-circle' fas /> Fourth-one
                                    </>
                                  ),
                                },
                                {
                                  name: (
                                    <>
                                      <MDBIcon icon='dot-circle' fas /> Fourth-two
                                    </>
                                  ),
                                },
                                {
                                  name: (
                                    <>
                                      <MDBIcon icon='dot-circle' fas /> Fourth-three
                                    </>
                                  ),
                                },
                              ],
                            },
                          ],
                        },
                      ],
                    },
                  ]}
                />
              );
            }
          
        
    

Color

Set the color of an active item using the color property.

Current color: primary
        
            
            import React, { useState } from 'react';
            import { MDBTreeview, MDBTreeviewItem } from 'mdb-react-treeview';
            import { MDBRow, MDBBtn } from 'mdb-react-ui-kit';

            export default function App() {
              const [color, setColor] = useState('primary');

              return (
                <>
                  <div className='text-center mb-5'>
                    <MDBBtn color='primary' onClick={() => setColor('primary')}>
                      Primary
                    </MDBBtn>
                    <MDBBtn color='secondary' onClick={() => setColor('secondary')}>
                      Secondary
                    </MDBBtn>
                    <MDBBtn color='warning' onClick={() => setColor('warning')}>
                      Warning
                    </MDBBtn>
                    <MDBBtn color='danger' onClick={() => setColor('danger')}>
                      Danger
                    </MDBBtn>
                    <MDBBtn color='info' onClick={() => setColor('info')}>
                      Info
                    </MDBBtn>
                    <MDBBtn color='success' onClick={() => setColor('success')}>
                      Success
                    </MDBBtn>
                    <MDBBtn color='dark' onClick={() => setColor('dark')}>
                      Dark
                    </MDBBtn>
                  </div>

                  <MDBRow className='mt-3'>
                    <MDBTreeview color={color}>
                      <MDBTreeviewItem name='One' />
                      <MDBTreeviewItem name='Two' />
                      <MDBTreeviewItem subtree show name='Three'>
                        <MDBTreeviewItem name='Second-one' />
                        <MDBTreeviewItem name='Second-two' />
                        <MDBTreeviewItem name='Second-three' subtree>
                          <MDBTreeviewItem name='Third-one' subtree>
                            <MDBTreeviewItem name='Fourth-one' />
                            <MDBTreeviewItem name='Fourth-two' />
                            <MDBTreeviewItem name='Fourth-three' />
                          </MDBTreeviewItem>
                          <MDBTreeviewItem name='Third-two' />
                          <MDBTreeviewItem name='Third-three' subtree>
                            <MDBTreeviewItem name='Fourth-one' />
                            <MDBTreeviewItem name='Fourth-two' />
                            <MDBTreeviewItem name='Fourth-three' />
                          </MDBTreeviewItem>
                        </MDBTreeviewItem>
                      </MDBTreeviewItem>
                    </MDBTreeview>
                  </MDBRow>
                </>
              );
            }
          
        
    

Line

Use a line property to set up an additional line in every nested list.

        
            
            import React from 'react';
            import { MDBTreeview, MDBTreeviewItem } from 'mdb-react-treeview';

            export default function App() {
              return (
                <MDBTreeview line>
                  <MDBTreeviewItem name='One' />
                  <MDBTreeviewItem name='Two' />
                  <MDBTreeviewItem subtree show name='Three'>
                    <MDBTreeviewItem name='Second-one' />
                    <MDBTreeviewItem name='Second-two' />
                    <MDBTreeviewItem name='Second-three' subtree>
                      <MDBTreeviewItem name='Third-one' subtree>
                        <MDBTreeviewItem name='Fourth-one' />
                        <MDBTreeviewItem name='Fourth-two' />
                        <MDBTreeviewItem name='Fourth-three' />
                      </MDBTreeviewItem>
                      <MDBTreeviewItem name='Third-two' />
                      <MDBTreeviewItem name='Third-three' subtree>
                        <MDBTreeviewItem name='Fourth-one' />
                        <MDBTreeviewItem name='Fourth-two' />
                        <MDBTreeviewItem name='Fourth-three' />
                      </MDBTreeviewItem>
                    </MDBTreeviewItem>
                  </MDBTreeviewItem>
                </MDBTreeview>
              );
            }
          
        
    

Disabled - JSX

        
            
            import React from 'react';
            import { MDBTreeview, MDBTreeviewItem } from 'mdb-react-treeview';

            export default function App() {
              return (
                <MDBTreeview selectable>
                  <MDBTreeviewItem name='One' />
                  <MDBTreeviewItem disabled name='Two' />
                  <MDBTreeviewItem subtree show name='Three'>
                    <MDBTreeviewItem name='Second-one' />
                    <MDBTreeviewItem name='Second-two' />
                    <MDBTreeviewItem name='Second-three' disabled subtree>
                      <MDBTreeviewItem name='Third-one' subtree>
                        <MDBTreeviewItem name='Fourth-one' />
                        <MDBTreeviewItem name='Fourth-two' />
                        <MDBTreeviewItem name='Fourth-three' />
                      </MDBTreeviewItem>
                      <MDBTreeviewItem name='Third-two' />
                      <MDBTreeviewItem name='Third-three' subtree>
                        <MDBTreeviewItem name='Fourth-one' />
                        <MDBTreeviewItem name='Fourth-two' />
                        <MDBTreeviewItem name='Fourth-three' />
                      </MDBTreeviewItem>
                    </MDBTreeviewItem>
                  </MDBTreeviewItem>
                </MDBTreeview>
              );
            }
          
        
    

Disabled - JavaScript

To generate a disabled list item, use disabled property.

        
            
            import React from 'react';
            import { MDBTreeview } from 'mdb-react-treeview';

            export default function App() {
              return (
                <MDBTreeview
                  items={[
                    { name: 'One', disabled: true },
                    { name: 'Two' },
                    {
                      name: ' Three',
                      show: true,
                      children: [
                        { name: 'Second-one' },
                        { name: 'Second-two' },
                        {
                          name: ' Second-three',
                          disabled: true,
                          children: [
                            {
                              name: ' Third-one',
                              children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                            },
                            { name: 'Third-two' },
                            {
                              name: ' Third-three',
                              children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                            },
                          ],
                        },
                      ],
                    },
                  ]}
                />
              );
            }
          
        
    

24H 00M 00S

Get one of the limited daily offers for AI Bundles with 98% OFF for our Black Days Sale!

Tree view - API


Import

        
            
            import { MDBTreeview, MDBTreeviewItem } from 'mdb-react-treeview';
          
        
    

Properties

MDBTreeview

Name Type Default Description Example
color string 'primary' Defines a text and background color for an active or hovered item <MDBTreeview color='secondary' />
getSelectedItem (item: React.MutableObjectRef<any>) => void Returns an item after selection <MDBTreeview getSelectedItem={(item: any) => console.log(item)} />
items Record<string,any> [] Defines an array of children to render <MDBTreeview items={childrenArray} />
line boolean false Adds a line to every nested list <MDBTreeview line />
openOnItemClick boolean true Enables opening list by clicking only on the icon <MDBTreeview openOnItemClick={false} />
selectable boolean false Setup checkboxes for the every list item <MDBTreeview selectable />
treeviewRef React.MutableObjectRef<any> A reference for the treeview component <MDBTreeview treeviewRef={someRef} />

MDBTreeviewItem

Name Type Default Description Example
disabled boolean Disables and item (with all children) <MDBTreeviewItem disabled />
icon string 'angle-right' Defines a custom expanding icon for the nested list <MDBTreeviewItem icon='angle-down' />
itemRef React.MutableObjectRef<any> A reference for the item element <MDBTreeviewItem itemRef={someRef} />
name React,ComponentProps<any> '' Defines an item text <MDBTreeviewItem name='One' />
rotationAngle number 90 Defines a rotation angle of the icons in nested lists <MDBTreeviewItem rotationAngle={180} />
show boolean false Defines if list is opened or not by default <MDBTreeviewItem subtree show />
subtree boolean false Declares a subtree item <MDBTreeviewItem subtree />

Events

MDBTreeview

Name Type Description
getSelectedItem (item: React.MutableObjectRef<any>) => void Returns an item after selection

Tree view

Angular Bootstrap 5 Tree view plugin

MDB treeview plugin is used to show hierarchical information which starts from the root item and proceed to its children and their respective children. Each item besides the root has a parent and can have children.

The parent is the node which is higher in the hierarchy and the child the one that is lower. Siblings are items which have one and the same parent. Items can be expanded and collapsed.

Note: Read the API tab to find all available options and advanced customization


Basic example

        
            
            <mdb-treeview
              textField="name"
              childrenField="children"
              [nodes]="data"
            ></mdb-treeview>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              data = [
                { name: 'One' },
                { name: 'Two' },
                {
                  name: 'Three',
                  children: [
                    { name: 'Second-one' },
                    { name: 'Second-two' },
                    {
                      name: 'Second-three',
                      children: [
                        {
                          name: 'Third-one',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                        { name: 'Third-two' },
                        {
                          name: 'Third-three',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                      ],
                    },
                  ],
                },
              ];
            };
          
        
    

Open on item click

Use a [openOnClick] to define opening lists of treeview by click only on the arrow or on the whole list item.

        
            
            <mdb-treeview
              textField="name"
              childrenField="children"
              [nodes]="data"
              [openOnClick]="false"
            ></mdb-treeview>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              data = [
                { name: 'One' },
                { name: 'Two' },
                {
                  name: 'Three',
                  children: [
                    { name: 'Second-one' },
                    { name: 'Second-two' },
                    {
                      name: 'Second-three',
                      children: [
                        {
                          name: 'Third-one',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                        { name: 'Third-two' },
                        {
                          name: 'Third-three',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                      ],
                    },
                  ],
                },
              ];
            };
          
        
    

Accordion

Use a [accordion] input to enable or disable opening only one list at the same level.

        
            
            <mdb-treeview
              textField="name"
              childrenField="children"
              [nodes]="data"
              [accordion]="true"
            ></mdb-treeview>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              data = [
                { name: 'One' },
                { name: 'Two' },
                {
                  name: 'Three',
                  children: [
                    { name: 'Second-one' },
                    { name: 'Second-two' },
                    {
                      name: 'Second-three',
                      children: [
                        {
                          name: 'Third-one',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                        { name: 'Third-two' },
                        {
                          name: 'Third-three',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                      ],
                    },
                  ],
                },
              ];
            };
          
        
    

Selectable

Use a [selectable] input to set up checkboxes in every list item.

        
            
            <mdb-treeview
              textField="name"
              childrenField="children"
              [nodes]="data"
              [selectable]="true"
            ></mdb-treeview>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              data = [
                { name: 'One' },
                { name: 'Two' },
                {
                  name: 'Three',
                  children: [
                    { name: 'Second-one' },
                    { name: 'Second-two' },
                    {
                      name: 'Second-three',
                      children: [
                        {
                          name: 'Third-one',
                          expandId: 'expand-example-item',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                        { name: 'Third-two' },
                        {
                          name: 'Third-three',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                      ],
                    },
                  ],
                },
              ];
            };
          
        
    

Expand

Expand your treeview to the particular list using the expand(ID) method.

        
            
            <button type="button" class="btn btn-primary" (click)="treeview.expand('expand-example-item')">
              Expand first list
            </button>
            <mdb-treeview
              #treeview="mdbTreeview"
              textField="name"
              childrenField="children"
              [nodes]="data"
            ></mdb-treeview>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              data = [
                { name: 'One' },
                { name: 'Two' },
                {
                  name: 'Three',
                  expandId: 'expand-example-item',
                  children: [
                    { name: 'Second-one' },
                    { name: 'Second-two' },
                    {
                      name: 'Second-three',
                      children: [
                        {
                          name: 'Third-one',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                        { name: 'Third-two' },
                        {
                          name: 'Third-three',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                      ],
                    },
                  ],
                },
              ];
            };
          
        
    

Collapse

Collapse your treeview using the collapse() method.

        
            
            <button type="button" class="btn btn-primary" (click)="treeview.collapse()">
              Collapse treeview
            </button>
            <mdb-treeview
              #treeview="mdbTreeview"
              textField="name"
              childrenField="children"
              [nodes]="data"
            ></mdb-treeview>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              data = [
                { name: 'One' },
                { name: 'Two' },
                {
                  name: 'Three',
                  collapsed: false,
                  children: [
                    { name: 'Second-one' },
                    { name: 'Second-two' },
                    {
                      name: 'Second-three',
                      collapsed: false,
                      children: [
                        {
                          name: 'Third-one',
                          collapsed: false,
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                        { name: 'Third-two' },
                        {
                          name: 'Third-three',
                          collapsed: false,
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                      ],
                    },
                  ],
                },
              };
          
        
    

Custom icons

Add icons to the list elements by pasting an icon code in the icon property.

Use a [rotationAngle] input to define a rotation angle of nested lists icons.

        
            
            <mdb-treeview
              textField="name"
              childrenField="children"
              [nodes]="data"
              [rotationAngle]="'90'"
            ></mdb-treeview>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              data = [
                { name: 'One', icon: 'fas fa-dot-circle' },
                { name: 'Two', icon: 'fas fa-dot-circle' },
                {
                  name: 'Three',
                  icon: 'fas fa-angle-double-right',
                  children: [
                    { name: 'Second-one', icon: 'fas fa-dot-circle' },
                    { name: 'Second-two', icon: 'fas fa-dot-circle' },
                    {
                      name: 'Second-three',
                      icon: 'fas fa-angle-double-right',
                      children: [
                        { name: 'Third-one', icon: 'fas fa-dot-circle' },
                        { name: 'Third-two', icon: 'fas fa-dot-circle' },
                        { name: 'Third-three', icon: 'fas fa-dot-circle' },
                      ],
                    },
                  ],
                },
              ];
            };
          
        
    

Color

Set the color of an active item using the [color] input.

Current color: primary
        
            
            <div class="text-center mb-5">
              <button (click)="setColor('primary')" type="button" class="btn btn-primary" id="primary">Primary</button>
              <button (click)="setColor('secondary')" type="button" class="btn btn-secondary" id="secondary">Secondary</button>
              <button (click)="setColor('warning')" type="button" class="btn btn-warning" id="warning">Warning</button>
              <button (click)="setColor('danger')" type="button" class="btn btn-danger" id="danger">Danger</button>
              <button (click)="setColor('info')" type="button" class="btn btn-info" id="info">Info</button>
              <button (click)="setColor('success')" type="button" class="btn btn-success" id="success">Success</button>
              <button (click)="setColor('dark')" type="button" class="btn btn-dark" id="dark">Dark</button>
            </div>
            <div class="row text-center">
              <h5>Current color: <span id="current-color">{{ color }}</span></h5>
            </div>
            <mdb-treeview
              textField="name"
              childrenField="children"
              [nodes]="data"
              [color]="color"
            ></mdb-treeview>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              color = 'primary';

              data = [
                { name: 'One' },
                { name: 'Two' },
                {
                  name: 'Three',
                  children: [
                    { name: 'Second-one' },
                    { name: 'Second-two' },
                    {
                      name: 'Second-three',
                      children: [
                        {
                          name: 'Third-one',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                        { name: 'Third-two' },
                        {
                          name: 'Third-three',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                      ],
                    },
                  ],
                },
              ];

              setColor(newColor) {
                this.color = newColor;
              }
            };
          
        
    

Line

Use a [line] input to set up an additional line in every nested list.

        
            
            <mdb-treeview
              textField="name"
              childrenField="children"
              [nodes]="data"
              [line]="true"
            ></mdb-treeview>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              data = [
                { name: 'One' },
                { name: 'Two' },
                {
                  name: 'Three',
                  children: [
                    { name: 'Second-one' },
                    { name: 'Second-two' },
                    {
                      name: 'Second-three',
                      children: [
                        {
                          name: 'Third-one',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                        { name: 'Third-two' },
                        {
                          name: 'Third-three',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                      ],
                    },
                  ],
                },
              ];
            };
          
        
    

Disabled

To generate a disabled list item, use disabled property. You can expand disabled items, but you can't select them.

        
            
            <mdb-treeview
              textField="name"
              childrenField="children"
              [nodes]="data"
              [selectable]="true"
            ></mdb-treeview>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              data = [
                { name: 'One' },
                { name: 'Two', disabled: true },
                {
                  name: 'Three',
                  children: [
                    { name: 'Second-one' },
                    { name: 'Second-two' },
                    {
                      name: 'Second-three',
                      disabled: true,
                      children: [
                        {
                          name: 'Third-one',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                        { name: 'Third-two' },
                        {
                          name: 'Third-three',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                      ],
                    },
                  ],
                },
              ];
            };
          
        
    

Filter

Use the .filter(string) method to expand list items that meet your requirements.

        
            
            <mdb-form-control>
              <input (change)="treeview.filter($event.target.value)" mdbInput type="text" id="form1" class="form-control" />
              <label mdbLabel class="form-label" for="form1">Find in the treeview</label>
            </mdb-form-control>
            <mdb-treeview
              #treeview="mdbTreeview"
              textField="name"
              childrenField="children"
              [nodes]="data"
            ></mdb-treeview>
          
        
    
        
            
            import { Component } from '@angular/core';
            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              data = [
                { name: 'One' },
                { name: 'Two' },
                {
                  name: 'Three',
                  children: [
                    { name: 'Second-one' },
                    { name: 'Second-two' },
                    {
                      name: 'Second-three',
                      children: [
                        {
                          name: 'Third-one',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                        { name: 'Third-two' },
                        {
                          name: 'Third-three',
                          children: [{ name: 'Fourth-one' }, { name: 'Fourth-two' }, { name: 'Fourth-three' }],
                        },
                      ],
                    },
                  ],
                },
              ];
            };
          
        
    

TAILWIND

GIFT for 2026

Purchase anything during the New Years Sale and get a Tailwind UI kit gift!

Tree view - API


Installation

To install and configure the plugin follow our Plugins Installation Guide. Please remember to update all the plugin names and import paths. You can find all the necessary information in the Import section.

        
            
     npm i git+https://oauth2:ACCESS_TOKEN@git.mdbootstrap.com/mdb/angular/mdb5/plugins/prd/treeview
     
        
    

Import

        
            
        import { MdbTreeviewModule } from 'mdb-angular-treeview';
        …
        @NgModule ({
          ...
          imports: [MdbTreeviewModule],
          ...
        })
        
        
    
        
            
        @import 'mdb-angular-treeview/scss/treeview.scss';
      
        
    

Inputs

Name Type Default Description
color MdbTreeviewColor 'primary' Defines a text and background color for an active or hovered item
openOnClick Boolean true Enables opening list by clicking only on the icon
selectable Boolean false Setup checkboxes for the every list item
accordion Boolean false Allows only one list on the same level to be opened
rotationAngle String 90 Defines a rotation angle of the icons in nested lists
line Boolean false Adds a line to every nested list

Outputs

Name Type Description
selected EventEmitter<any> This output fires immediately when one of the treeview checkboxes are changed.
activeItemChange EventEmitter<ElementRef> This event fires immediately when one of the treeview list items are selected by click.
        
            
            <mdb-treeview
            textField="name"
            childrenField="children"
            [nodes]="data"
            (activeItemChange)="onActiveItemChange($event)"
          ></mdb-treeview>                                    
            
        
    
        
            
            import { Component, ElementRef } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              data = [
                { name: 'One' },
                { name: 'Two' },
                {
                  name: 'Three',
                  children: [
                    { name: 'Second-one' },
                    { name: 'Second-two' },
                    {
                      name: 'Second-three',
                      children: [
                        {
                          name: 'Third-one',
                          children: [
                            { name: 'Fourth-one' },
                            { name: 'Fourth-two' },
                            { name: 'Fourth-three' },
                          ],
                        },
                        { name: 'Third-two' },
                        {
                          name: 'Third-three',
                          children: [
                            { name: 'Fourth-one' },
                            { name: 'Fourth-two' },
                            { name: 'Fourth-three' },
                          ],
                        },
                      ],
                    },
                  ],
                },
              ];
            
              onActiveItemChange(event: ElementRef): void {
                console.log('onActiveItemChange: ', event);
              }
            }                                       
            
        
    

Methods

Name Description Example
collapse Collapses every list in treeview treeview.collapse()
expand(id:string) Expands a treeview to the list with a particular ID treeview.expand('example-id')
filter(value:string) Expands list items that meet your requirements treeview.filter('Name')
        
            
          <button class="btn btn-lg" (click)="treeview.collapse()">Collapse tree</button>
          <mdb-treeview
            #treeview
            textField="name"
            childrenField="children"
            [nodes]="data"
          ></mdb-treeview>                   
          
        
    
        
            
          import { Component } from '@angular/core';

          @Component({
            selector: 'app-root',
            templateUrl: './app.component.html',
            styleUrls: ['./app.component.scss'],
          })
          export class AppComponent {
            data = [
              { name: 'One' },
              { name: 'Two' },
              {
                name: 'Three',
                children: [
                  { name: 'Second-one' },
                  { name: 'Second-two' },
                  {
                    name: 'Second-three',
                    children: [
                      {
                        name: 'Third-one',
                        children: [
                          { name: 'Fourth-one' },
                          { name: 'Fourth-two' },
                          { name: 'Fourth-three' },
                        ],
                      },
                      { name: 'Third-two' },
                      {
                        name: 'Third-three',
                        children: [
                          { name: 'Fourth-one' },
                          { name: 'Fourth-two' },
                          { name: 'Fourth-three' },
                        ],
                      },
                    ],
                  },
                ],
              },
            ];
          }